import java.util.ArrayList;
import java.util.Date;


public class Issue {

	private String pkey;
	private String priorite;
	private Date creation;
	private Date updated;
	private ArrayList etapes;
	
	private ArrayList listTMAC01;
	private ArrayList listTMAC02;
	private ArrayList listTMAC03;
		
	/* Rsultats des indicateurs */
	private int [] TMAC01; //
	private int [] TMAC02; //Somme des dures des tapes 12
	private int [] TMAC03; //Somme des dures des tapes 3
	
	public Issue() {
		this.pkey = new String();
		this.priorite = new String();
		this.creation = new Date();
		this.updated = new Date();
		this.etapes = new ArrayList();
		this.listTMAC01 = new ArrayList();
		this.listTMAC02 = new ArrayList();
		this.listTMAC03 = new ArrayList();
		this.TMAC01 = new int[3];
		this.TMAC02 = new int[3];
		this.TMAC03 = new int[3];
	}

	public String getPkey() {
		return pkey;
	}
	public void setPkey(String pkey) {
		this.pkey = pkey;
	}

	public ArrayList getEtapes() {
		return etapes;
	}

	public void setEtapes(ArrayList etapes) {
		this.etapes = etapes;
	}

	public void setPriorite(String priorite) {
		this.priorite = priorite;
	}

	public String getPriorite() {
		return priorite;
	}

	public ArrayList getListTMAC01() {
		return listTMAC01;
	}
	public void setListTMAC01(ArrayList listTMAC01) {
		this.listTMAC01 = listTMAC01;
	}
	public ArrayList getListTMAC02() {
		return listTMAC02;
	}
	public void setListTMAC02(ArrayList listTMAC02) {
		this.listTMAC02 = listTMAC02;
	}
	public ArrayList getListTMAC03() {
		return listTMAC03;
	}
	public void setListTMAC03(ArrayList listTMAC03) {
		this.listTMAC03 = listTMAC03;
	}
	public int[] getTMAC01() {
		return TMAC01;
	}
	public void setTMAC01(int[] tmac01) {
		TMAC01 = tmac01;
	}
	public int[] getTMAC02() {
		return TMAC02;
	}
	public void setTMAC02(int[] tmac02) {
		TMAC02 = tmac02;
	}
	public int[] getTMAC03() {
		return TMAC03;
	}
	public void setTMAC03(int[] tmac03) {
		TMAC03 = tmac03;
	}

	public Date getCreation() {
		return creation;
	}
	public void setCreation(Date creation) {
		this.creation = creation;
	}
	public Date getUpdated() {
		return updated;
	}
	public void setUpdated(Date updated) {
		this.updated = updated;
	}
	
	public void init() {
		
	}
	
	/**
	 * Fonction qui calcul la somme des dures passe sur chaque tapes
	 */
	public void calculTMACs() {
		int [] tmac01 = sumOfPeriod(this.getListTMAC01());
		int [] tmac02 = sumOfPeriod(this.getListTMAC02());
		int [] tmac03 = sumOfPeriod(this.getListTMAC03());
		
		this.setTMAC01(tmac01);
		this.setTMAC02(tmac02);
		this.setTMAC03(tmac03);		
	}
	
	public void addTMADelay(StepIssue stepIssue) {
		int [] tmac = new int[3];
		
		tmac[0] = stepIssue.getPeriode()[0];
		tmac[1] = stepIssue.getPeriode()[1];
		tmac[2] = stepIssue.getPeriode()[2];
			
		if(stepIssue.getStepId() == 1 || stepIssue.getStepId() == 2) this.getListTMAC01().add(tmac);
		else if(stepIssue.getStepId() == 3 || stepIssue.getStepId() == 12) this.getListTMAC03().add(tmac);
	}
	
	public int [] sumOfPeriod(ArrayList tmacList) {
		int [] sumPeriod = new int [3];
		for(int i = 0; i < tmacList.size(); i++) {
			int [] tmacTmp = (int[]) tmacList.get(i);
			for(int j = 0; j < tmacTmp.length; j++) {
				sumPeriod[j] += tmacTmp[j];
			}
		}
		
		while(sumPeriod[2] >= 60) {
			sumPeriod[2] -= 60;
			sumPeriod[1] ++;
		}
		
		while(sumPeriod[1] >= 24) {
			sumPeriod[1] -= 24;
			sumPeriod[0] ++;
		}
		
		return sumPeriod;
	}
	
	/*public void verifContraintes() {
		
		Integer priority = new Integer(this.getPriorite());
		int [] tmaContratC01 = JiraOperation.TMAC01[priority.intValue()-1]; //Indice du tableau
		int [] tmaContratC02 = JiraOperation.TMAC02[priority.intValue()-1];
		int [] tmaContratC03 = JiraOperation.TMAC03[priority.intValue()-1];
		
		System.out.println("TMAC01Contrat : "+tmaContratC01[0]);
		
		if(this.getTMAC01Periode()[0] < tmaContratC01[0]) this.succes++; 		//NbJour reel < NbJour contrat
		else if(this.getTMAC01Periode()[0] == tmaContratC01[0]) {				//Sinon on regarde les heures si NbJour reel = NbJour contrat
			if(this.getTMAC01Periode()[1] < tmaContratC01[1]) this.succes++;	//NbHeure reelle < NbHeure contrat
			else if(this.getTMAC01Periode()[1] == tmaContratC01[1]){
				if(this.getTMAC01Periode()[2] < tmaContratC01[2]) this.succes++;
			}
		}
		
		if(this.getTMAC02Periode()[0] < tmaContratC02[0]) this.succes++; 		//NbJour reel < NbJour contrat
		else if(this.getTMAC02Periode()[0] == tmaContratC02[0]) {				//Sinon on regarde les heures si NbJour reel = NbJour contrat
			if(this.getTMAC02Periode()[1] < tmaContratC02[1]) this.succes++;	//NbHeure reelle < NbHeure contrat
			else if(this.getTMAC02Periode()[1] == tmaContratC02[1]){
				if(this.getTMAC02Periode()[2] < tmaContratC02[2]) this.succes++;
			}
		}
		
		if(this.getTMAC03Periode()[0] < tmaContratC03[0]) this.succes++; 		//NbJour reel < NbJour contrat
		else if(this.getTMAC03Periode()[0] == tmaContratC03[0]) {				//Sinon on regarde les heures si NbJour reel = NbJour contrat
			if(this.getTMAC03Periode()[1] < tmaContratC03[1]) this.succes++;	//NbHeure reelle < NbHeure contrat
			else if(this.getTMAC03Periode()[1] == tmaContratC03[1]){
				if(this.getTMAC03Periode()[2] < tmaContratC03[2]) this.succes++;
			}
		}
	}*/
}
