import java.util.Date;


public class StepIssue {
	
	private int stepId;
	private Date debut;
	private Date fin;
	private int [] periode;
		
	public StepIssue() {
		this.debut = new Date();
		this.fin = new Date();
		this.periode = new int[3];
	}
	public StepIssue(int stepId, Date debut, Date fin, int [] periode, String duree) {
		this.stepId = stepId;
		this.debut = debut;
		this.fin = fin;
		this.periode = periode;
	}
	
	public int getStepId() {
		return stepId;
	}
	public void setStepId(int stepId) {
		this.stepId = stepId;
	}
	public Date getDebut() {
		return this.debut;
	}
	public void setDebut(Date myDate) {
		this.debut = myDate;
	}
	public void setFin(Date fin) {
		this.fin = fin;
	}
	public Date getFin() {
		return fin;
	}
	public void setPeriode(int [] periode) {
		this.periode = periode;
	}
	public int [] getPeriode() {
		return periode;
	}

	public void init() {
		int nbJour = DateFunction.calculJour(this.getDebut(), this.getFin());
		int [] time = DateFunction.calculHeure(this.getDebut(), this.getFin());
		
		int [] tmpPeriode = new int[3];
		tmpPeriode[0] = nbJour;
		tmpPeriode[1] = time[0];
		tmpPeriode[2] = time[1];
		
		this.setPeriode(tmpPeriode);
	}
	
	public static String displayPeriod(int [] time) {
		
		Integer totalJour = time[0];
		Integer totalHeure = time[1];
		Integer totalMin = time[2];
		
		String strJour = totalJour.toString();
		String strHeure = totalHeure.toString();
		String strMin = totalMin.toString();
		
		if(strJour.length() == 1) strJour = "0"+strJour;
		if(strHeure.length() == 1) strHeure = "0"+strHeure;
		if(strMin.length() == 1) strMin = "0"+strMin;
		
		return strJour+"j "+strHeure+":"+strMin;
		
	}
}
